// ============================================================ //
#ifndef _MQ6835_IAP_CFG_H__
#define _MQ6835_IAP_CFG_H__
// ============================================================ //

void iap_boot( void);

/* -------------------------------------------------------------*/
// Normal boot start address
// 趨ʼλ
#define NORMAL_BOOT_ADDRESS		(0x8500)
/* -------------------------------------------------------------*/

/*--------------------------------------------------------------*/
// UART Interface Select
// ̬1~2 ѡһΪ IAP UART ʹ

#define IAP_UART_TX20_RX21
//#define IAP_UART_TX21_RX20
//#define IAP_UART_TX26_RX27
//#define IAP_UART_TX27_RX26
//#define IAP_UART_TX90_RX91
//#define IAP_UART_TX91_RX90
/* -------------------------------------------------------------*/ 

/* -------------------------------------------------------------*/
// Baud Rate Select
// ̬ѡһΪ IAP UART Baudrate Speedʹ

#define BAUDRATE_115200
//#define BAUDRATE_57600
//#define BAUDRATE_38400
//#define BAUDRATE_19200
//#define BAUDRATE_9600
//#define BAUDRATE_4800
/*--------------------------------------------------------------*/

/*--------------------------------------------------------------*/
// UART Control Setting (parity / stop bit / even)
#define UART_CR1_VALUE       (0x00)
#define UART_CR2_VALUE       (0x00)
/*--------------------------------------------------------------*/

/* -------------------------------------------------------------*/
// Enable Boot PIN Setting: 
// ̬ѡһΪ IAP Boot ʹ

// #define IAP_BOOT_PIN_P00
// #define IAP_BOOT_PIN_P01
// #define IAP_BOOT_PIN_P20
// #define IAP_BOOT_PIN_P21
// #define IAP_BOOT_PIN_P22
// #define IAP_BOOT_PIN_P23
// #define IAP_BOOT_PIN_P24
// #define IAP_BOOT_PIN_P25
// #define IAP_BOOT_PIN_P26
// #define IAP_BOOT_PIN_P27
 #define IAP_BOOT_PIN_P42
// #define IAP_BOOT_PIN_P43
// #define IAP_BOOT_PIN_P44
// #define IAP_BOOT_PIN_P45
// #define IAP_BOOT_PIN_P46
// #define IAP_BOOT_PIN_P47
// #define IAP_BOOT_PIN_P51
// #define IAP_BOOT_PIN_P52
// #define IAP_BOOT_PIN_P53
// #define IAP_BOOT_PIN_P54
// #define IAP_BOOT_PIN_P55
// #define IAP_BOOT_PIN_P56
// #define IAP_BOOT_PIN_P57
// #define IAP_BOOT_PIN_P70
// #define IAP_BOOT_PIN_P71
// #define IAP_BOOT_PIN_P72
// #define IAP_BOOT_PIN_P73
// #define IAP_BOOT_PIN_P74
// #define IAP_BOOT_PIN_P75
// #define IAP_BOOT_PIN_P76
// #define IAP_BOOT_PIN_P77
// #define IAP_BOOT_PIN_P80
// #define IAP_BOOT_PIN_P81
// #define IAP_BOOT_PIN_P82
// #define IAP_BOOT_PIN_P83
// #define IAP_BOOT_PIN_P84
// #define IAP_BOOT_PIN_P85
// #define IAP_BOOT_PIN_P86
// #define IAP_BOOT_PIN_P87
// #define IAP_BOOT_PIN_P90
// #define IAP_BOOT_PIN_P91
// #define IAP_BOOT_PIN_P92
// #define IAP_BOOT_PIN_P93
/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/
// 趨 IAP Boot (ʼ)λ
// Default High = 0x01;
//         Low  = 0x00;
#define IAP_BOOT_GPIO_DEFAULT_HIGH_LOW (0x00)
/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/
// 趨 IAP Boot ()λ
// Enable  High = 0x01
//         Low  = 0x00
#define IAP_BOOT_GPIO_ENABLE_HIGH_LOW  (0x01)
/* -------------------------------------------------------------*/

// IAP Boot related data structure
typedef struct
{
	// Memory address related
	unsigned int    norBootAddr;
	
	// Boot pin related
	volatile unsigned char	 *ptrBootPinPU;     // pointer to Boot GPIO Pin Pull-Up register
	volatile unsigned char	 *ptrBootPinPD;     // pointer to Boot GPIO Pin Pull-Down register
	volatile unsigned char	 *ptrBootPinPRD;    // pointer to Boot GPIO Pin PRD register
	volatile unsigned char	 valBootDefaultHL; // pointer to Boot GPIO Default High/Low
	volatile unsigned char	 valBootEnableHL;  // pointer to Boot GPIO Enable High/Low
	unsigned char              valBootPinBit;                 // Ex 0x02 is Px2
	
	// UART releted
	volatile unsigned char    *ptrUartPinCR;
	volatile unsigned char    *ptrUartPinFC;
	volatile unsigned char    valUartTxPin;
	volatile unsigned char    valUartRxPin;
	volatile unsigned char    valUATCNG;
	volatile unsigned char    valPOFFCR1;
	
	volatile unsigned char	 *ptrUartTxRxBUF;        // Pointer to UART Tx device buffer (ex. 0x001) 
	volatile unsigned char	 *ptrUartSR;        // UART status byte(bit0: TBFL 0:buffer empty,  1:buffer full) 
	volatile unsigned char    valUartDR;
	volatile unsigned char    valUartRTSEL;
	volatile unsigned char    valUartCR1;
	volatile unsigned char    valUartCR2;

}IAP_Define;


extern IAP_Define IAP_Dev_define;   // define IAP related registers & runtime variable

/*--------------------------------------------------------------*/
#if(1)// IAP UART configure define detail 
#ifdef IAP_UART_TX20_RX21
// 1. UART0 Tx: P20 Rx: P21        -->
#define IAP_UART_CR_ADR         (0x0F1C)
#define IAP_UART_TX_PIN         (0x01)
#define IAP_UART_RX_PIN			(0x02)
#define IAP_UART_FC_ADR         (0x0F36)

#define IAP_UART_POFFCR1_VALUE  (0x01)         // UART0
#define IAP_UART_UATCNG_VALUE   (0x00)
#define IAP_UART_TDRDBUF_ADR    (0x001E)       // UART0 Tx Rx buffer register address
#define IAP_UART_SR_ADR         (0x001D)       // UART0 Status register address
#define IAP_UART_DR_ADR         (0x001C)
#define IAP_UART_CR1_ADR        (0x001A)
#define IAP_UART_CR2_ADR        (0x001B)
#endif

#ifdef IAP_UART_TX21_RX20
// 2. UART0 Tx: P21 Rx: P20        -->
#define IAP_UART_CR_ADR         (0x0F1C)
#define IAP_UART_TX_PIN         (0x02)
#define IAP_UART_RX_PIN			(0x01)
#define IAP_UART_FC_ADR         (0x0F36)

#define IAP_UART_POFFCR1_VALUE  (0x01)         // UART0
#define IAP_UART_UATCNG_VALUE   (0x01)
#define IAP_UART_TDRDBUF_ADR    (0x001E)       // UART0 Tx Rx buffer register address
#define IAP_UART_SR_ADR         (0x001D)       // UART0 Status register address
#define IAP_UART_DR_ADR         (0x001C)
#define IAP_UART_CR1_ADR        (0x001A)
#define IAP_UART_CR2_ADR        (0x001B)
#endif 

#ifdef IAP_UART_TX26_RX27
// 3. UART1 Tx: P26 Rx: P27        -->
#define IAP_UART_CR_ADR         (0x0F1C)
#define IAP_UART_TX_PIN         (0x40)
#define IAP_UART_RX_PIN			(0x80)
#define IAP_UART_FC_ADR         (0x0F36)

#define IAP_UART_POFFCR1_VALUE  (0x02)         // UART1
#define IAP_UART_UATCNG_VALUE   (0x04)         
#define IAP_UART_TDRDBUF_ADR    (0x0F58)       // UART1 Tx Rx buffer register address
#define IAP_UART_SR_ADR         (0x0F57)       // UART1 Status register address 
#define IAP_UART_DR_ADR         (0x0F56)
#define IAP_UART_CR1_ADR        (0x0F54)
#define IAP_UART_CR2_ADR        (0x0F55)
#endif

#ifdef IAP_UART_TX27_RX26
// 4. UART1 Tx: P27 Rx: P26        -->
#define IAP_UART_CR_ADR         (0x0F1C)
#define IAP_UART_TX_PIN         (0x80)
#define IAP_UART_RX_PIN			(0x40)
#define IAP_UART_FC_ADR         (0x0F36)

#define IAP_UART_POFFCR1_VALUE  (0x02)         // UART1
#define IAP_UART_UATCNG_VALUE   (0x06)
#define IAP_UART_TDRDBUF_ADR    (0x0F58)       // UART1 Tx Rx buffer register address
#define IAP_UART_SR_ADR         (0x0F57)       // UART1 Status register address
#define IAP_UART_DR_ADR         (0x0F56)
#define IAP_UART_CR1_ADR        (0x0F54)
#define IAP_UART_CR2_ADR        (0x0F55)
#endif


#ifdef IAP_UART_TX90_RX91
// 5. UART1 Tx: P90 Rx: P91        -->
#define IAP_UART_CR_ADR         (0x0F23)
#define IAP_UART_TX_PIN         (0x01)
#define IAP_UART_RX_PIN			(0x01)
#define IAP_UART_FC_ADR         (0x0F3D)

#define IAP_UART_POFFCR1_VALUE  (0x02)         // UART1
#define IAP_UART_UATCNG_VALUE   (0x00)
#define IAP_UART_TDRDBUF_ADR    (0x0F58)       // UART1 Tx Rx buffer register address
#define IAP_UART_SR_ADR         (0x0F57)       // UART1 Status register address
#define IAP_UART_DR_ADR         (0x0F56)
#define IAP_UART_CR1_ADR        (0x0F54)
#define IAP_UART_CR2_ADR        (0x0F55)
#endif


#ifdef IAP_UART_TX91_RX90
// 6. UART1 Tx: P91 Rx: P90        -->
#define IAP_UART_CR_ADR         (0x0F23)
#define IAP_UART_TX_PIN         (0x02)
#define IAP_UART_RX_PIN			(0x00)
#define IAP_UART_FC_ADR         (0x0F3D)

#define IAP_UART_POFFCR1_VALUE  (0x02)         // UART1
#define IAP_UART_UATCNG_VALUE   (0x02)
#define IAP_UART_TDRDBUF_ADR    (0x0F58)       // UART1 Tx Rx buffer register address
#define IAP_UART_SR_ADR         (0x0F57)       // UART1 Status register address
#define IAP_UART_DR_ADR         (0x0F56)
#define IAP_UART_CR1_ADR        (0x0F54)
#define IAP_UART_CR2_ADR        (0x0F55)
#endif 
#endif
/* -------------------------------------------------------------*/

/*--------------------------------------------------------------*/
#if(1)// IA UART baud rate speed define detail
#ifdef  BAUDRATE_115200
#define BAUDRATE_DR_VALUE       (0x08)
#define BAUDRATE_RTSEL_VALUE    (0x03 << 3) 
#endif

#ifdef  BAUDRATE_57600
#define BAUDRATE_DR_VALUE       (0x11)
#define BAUDRATE_RTSEL_VALUE    (0x03 << 3) 
#endif

#ifdef  BAUDRATE_38400
#define BAUDRATE_DR_VALUE       (0x19)
#define BAUDRATE_RTSEL_VALUE    (0x00 << 3) 
#endif

#ifdef  BAUDRATE_19200
#define BAUDRATE_DR_VALUE       (0x30)
#define BAUDRATE_RTSEL_VALUE    (0x40 << 3) 
#endif

#ifdef  BAUDRATE_9600
#define BAUDRATE_DR_VALUE       (0x64)
#define BAUDRATE_RTSEL_VALUE    (0x01 << 3) 
#endif

#ifdef  BAUDRATE_4800
#define BAUDRATE_DR_VALUE       (0xC9)
#define BAUDRATE_RTSEL_VALUE    (0x01 << 3) 
#endif
#endif
/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/
#if(1)// Boot pin define register detail
#ifdef IAP_BOOT_PIN_P00
#define IAP_BOOT_PIN_FC_REG                      (0x0F34)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F27)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F00)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1A)
#define IAP_BOOT_PIN_PRD_REG                     (0x000D)
#define IAP_BOOT_PIN_BIT                         (0x01)
#endif

#ifdef IAP_BOOT_PIN_P01
#define IAP_BOOT_PIN_FC_REG                      (0x0F34)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F27)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F00)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1A)
#define IAP_BOOT_PIN_PRD_REG                     (0x000D)
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

#ifdef IAP_BOOT_PIN_P20
#define IAP_BOOT_PIN_FC_REG                      (0x0F36)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F29)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F02)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1C)
#define IAP_BOOT_PIN_PRD_REG                     (0x000F)
#define IAP_BOOT_PIN_BIT                         (0x01)
#endif

#ifdef IAP_BOOT_PIN_P21
#define IAP_BOOT_PIN_FC_REG                      (0x0F36)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F29)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F02)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1C)
#define IAP_BOOT_PIN_PRD_REG                     (0x000F)
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

#ifdef IAP_BOOT_PIN_P22
#define IAP_BOOT_PIN_FC_REG                      (0x0F36)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F29)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F02)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1C)
#define IAP_BOOT_PIN_PRD_REG                     (0x000F)
#define IAP_BOOT_PIN_BIT                         (0x04)
#endif

#ifdef IAP_BOOT_PIN_P23
#define IAP_BOOT_PIN_FC_REG                      (0x0F36)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F29)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F02)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1C)
#define IAP_BOOT_PIN_PRD_REG                     (0x000F)
#define IAP_BOOT_PIN_BIT                         (0x08)
#endif

#ifdef IAP_BOOT_PIN_P24
#define IAP_BOOT_PIN_FC_REG                      (0x0F36)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F29)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F02)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1C)
#define IAP_BOOT_PIN_PRD_REG                     (0x000F)
#define IAP_BOOT_PIN_BIT                         (0x10)
#endif

#ifdef IAP_BOOT_PIN_P25
#define IAP_BOOT_PIN_FC_REG                      (0x0F36)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F29)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F02)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1C)
#define IAP_BOOT_PIN_PRD_REG                     (0x000F)
#define IAP_BOOT_PIN_BIT                         (0x20)
#endif

#ifdef IAP_BOOT_PIN_P26
#define IAP_BOOT_PIN_FC_REG                      (0x0F36)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F29)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F02)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1C)
#define IAP_BOOT_PIN_PRD_REG                     (0x000F)
#define IAP_BOOT_PIN_BIT                         (0x40)
#endif

#ifdef IAP_BOOT_PIN_P27
#define IAP_BOOT_PIN_FC_REG                      (0x0F36)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F29)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F02)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1C)
#define IAP_BOOT_PIN_PRD_REG                     (0x000F)
#define IAP_BOOT_PIN_BIT                         (0x80)
#endif

#ifdef IAP_BOOT_PIN_P40
#define IAP_BOOT_PIN_FC_REG                      (0x0F38)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2B)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F04)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1E)
#define IAP_BOOT_PIN_PRD_REG                     (0x0011)
#define IAP_BOOT_PIN_BIT                         (0x01)
#endif

#ifdef IAP_BOOT_PIN_P41
#define IAP_BOOT_PIN_FC_REG                      (0x0F38)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2B)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F04)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1E)
#define IAP_BOOT_PIN_PRD_REG                     (0x0011)
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

#ifdef IAP_BOOT_PIN_P42
#define IAP_BOOT_PIN_FC_REG                      (0x0F38)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2B)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F04)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1E)
#define IAP_BOOT_PIN_PRD_REG                     (0x0011)
#define IAP_BOOT_PIN_BIT                         (0x04)
#endif

#ifdef IAP_BOOT_PIN_P43
#define IAP_BOOT_PIN_FC_REG                      (0x0F38)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2B)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F04)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1E)
#define IAP_BOOT_PIN_PRD_REG                     (0x0011)
#define IAP_BOOT_PIN_BIT                         (0x08)
#endif

#ifdef IAP_BOOT_PIN_P44
#define IAP_BOOT_PIN_FC_REG                      (0x0F38)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2B)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F04)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1E)
#define IAP_BOOT_PIN_PRD_REG                     (0x0011)
#define IAP_BOOT_PIN_BIT                         (0x10)
#endif

#ifdef IAP_BOOT_PIN_P45
#define IAP_BOOT_PIN_FC_REG                      (0x0F38)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2B)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F04)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1E)
#define IAP_BOOT_PIN_PRD_REG                     (0x0011)
#define IAP_BOOT_PIN_BIT                         (0x20)
#endif

#ifdef IAP_BOOT_PIN_P46
#define IAP_BOOT_PIN_FC_REG                      (0x0F38)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2B)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F04)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1E)
#define IAP_BOOT_PIN_PRD_REG                     (0x0011)
#define IAP_BOOT_PIN_BIT                         (0x40)
#endif

#ifdef IAP_BOOT_PIN_P47
#define IAP_BOOT_PIN_FC_REG                      (0x0F38)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2B)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F04)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1E)
#define IAP_BOOT_PIN_PRD_REG                     (0x0011)
#define IAP_BOOT_PIN_BIT                         (0x80)
#endif

#ifdef IAP_BOOT_PIN_P51
#define IAP_BOOT_PIN_FC_REG                      (0x0F39)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2C)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F05)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1F)
#define IAP_BOOT_PIN_PRD_REG                     (0x0012)
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

#ifdef IAP_BOOT_PIN_P52
#define IAP_BOOT_PIN_FC_REG                      (0x0F39)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2C)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F05)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1F)
#define IAP_BOOT_PIN_PRD_REG                     (0x0012)
#define IAP_BOOT_PIN_BIT                         (0x04)
#endif

#ifdef IAP_BOOT_PIN_P53
#define IAP_BOOT_PIN_FC_REG                      (0x0F39)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2C)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F05)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1F)
#define IAP_BOOT_PIN_PRD_REG                     (0x0012)
#define IAP_BOOT_PIN_BIT                         (0x08)
#endif

#ifdef IAP_BOOT_PIN_P54
#define IAP_BOOT_PIN_FC_REG                      (0x0F39)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2C)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F05)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1F)
#define IAP_BOOT_PIN_PRD_REG                     (0x0012)
#define IAP_BOOT_PIN_BIT                         (0x10)
#endif

#ifdef IAP_BOOT_PIN_P55
#define IAP_BOOT_PIN_FC_REG                      (0x0F39)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2C)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F05)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1F)
#define IAP_BOOT_PIN_PRD_REG                     (0x0012)
#define IAP_BOOT_PIN_BIT                         (0x20)
#endif

#ifdef IAP_BOOT_PIN_P56
#define IAP_BOOT_PIN_FC_REG                      (0x0F39)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2C)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F05)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1F)
#define IAP_BOOT_PIN_PRD_REG                     (0x0012)
#define IAP_BOOT_PIN_BIT                         (0x40)
#endif

#ifdef IAP_BOOT_PIN_P57
#define IAP_BOOT_PIN_FC_REG                      (0x0F39)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2C)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F05)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1F)
#define IAP_BOOT_PIN_PRD_REG                     (0x0012)
#define IAP_BOOT_PIN_BIT                         (0x80)
#endif

#ifdef IAP_BOOT_PIN_P70
#define IAP_BOOT_PIN_FC_REG                      (0x0F3B)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2E)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F07)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F21)
#define IAP_BOOT_PIN_PRD_REG                     (0x0014)
#define IAP_BOOT_PIN_BIT                         (0x01)
#endif

#ifdef IAP_BOOT_PIN_P71
#define IAP_BOOT_PIN_FC_REG                      (0x0F3B)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2E)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F07)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F21)
#define IAP_BOOT_PIN_PRD_REG                     (0x0014)
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

#ifdef IAP_BOOT_PIN_P72
#define IAP_BOOT_PIN_FC_REG                      (0x0F3B)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2E)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F07)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F21)
#define IAP_BOOT_PIN_PRD_REG                     (0x0014)
#define IAP_BOOT_PIN_BIT                         (0x04)
#endif

#ifdef IAP_BOOT_PIN_P73
#define IAP_BOOT_PIN_FC_REG                      (0x0F3B)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2E)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F07)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F21)
#define IAP_BOOT_PIN_PRD_REG                     (0x0014)
#define IAP_BOOT_PIN_BIT                         (0x08)
#endif

#ifdef IAP_BOOT_PIN_P74
#define IAP_BOOT_PIN_FC_REG                      (0x0F3B)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2E)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F07)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F21)
#define IAP_BOOT_PIN_PRD_REG                     (0x0014)
#define IAP_BOOT_PIN_BIT                         (0x10)
#endif

#ifdef IAP_BOOT_PIN_P75
#define IAP_BOOT_PIN_FC_REG                      (0x0F3B)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2E)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F07)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F21)
#define IAP_BOOT_PIN_PRD_REG                     (0x0014)
#define IAP_BOOT_PIN_BIT                         (0x20)
#endif

#ifdef IAP_BOOT_PIN_P76
#define IAP_BOOT_PIN_FC_REG                      (0x0F3B)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2E)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F07)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F21)
#define IAP_BOOT_PIN_PRD_REG                     (0x0014)
#define IAP_BOOT_PIN_BIT                         (0x40)
#endif

#ifdef IAP_BOOT_PIN_P77
#define IAP_BOOT_PIN_FC_REG                      (0x0F3B)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2E)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F07)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F21)
#define IAP_BOOT_PIN_PRD_REG                     (0x0014)
#define IAP_BOOT_PIN_BIT                         (0x80)
#endif

#ifdef IAP_BOOT_PIN_P80
#define IAP_BOOT_PIN_FC_REG                      (0x0F3C)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2F)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F08)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F22)
#define IAP_BOOT_PIN_PRD_REG                     (0x0015)
#define IAP_BOOT_PIN_BIT                         (0x01)
#endif

#ifdef IAP_BOOT_PIN_P81
#define IAP_BOOT_PIN_FC_REG                      (0x0F3C)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2F)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F08)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F22)
#define IAP_BOOT_PIN_PRD_REG                     (0x0015)
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

#ifdef IAP_BOOT_PIN_P82
#define IAP_BOOT_PIN_FC_REG                      (0x0F3C)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2F)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F08)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F22)
#define IAP_BOOT_PIN_PRD_REG                     (0x0015)
#define IAP_BOOT_PIN_BIT                         (0x04)
#endif

#ifdef IAP_BOOT_PIN_P83
#define IAP_BOOT_PIN_FC_REG                      (0x0F3C)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2F)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F08)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F22)
#define IAP_BOOT_PIN_PRD_REG                     (0x0015)
#define IAP_BOOT_PIN_BIT                         (0x08)
#endif

#ifdef IAP_BOOT_PIN_P84
#define IAP_BOOT_PIN_FC_REG                      (0x0F3C)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2F)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F08)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F22)
#define IAP_BOOT_PIN_PRD_REG                     (0x0015)
#define IAP_BOOT_PIN_BIT                         (0x10)
#endif

#ifdef IAP_BOOT_PIN_P85
#define IAP_BOOT_PIN_FC_REG                      (0x0F3C)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2F)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F08)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F22)
#define IAP_BOOT_PIN_PRD_REG                     (0x0015)
#define IAP_BOOT_PIN_BIT                         (0x20)
#endif

#ifdef IAP_BOOT_PIN_P86
#define IAP_BOOT_PIN_FC_REG                      (0x0F3C)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2F)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F08)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F22)
#define IAP_BOOT_PIN_PRD_REG                     (0x0015)
#define IAP_BOOT_PIN_BIT                         (0x40)
#endif

#ifdef IAP_BOOT_PIN_P87
#define IAP_BOOT_PIN_FC_REG                      (0x0F3C)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2F)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F08)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F22)
#define IAP_BOOT_PIN_PRD_REG                     (0x0015)
#define IAP_BOOT_PIN_BIT                         (0x80)
#endif

#ifdef IAP_BOOT_PIN_P90
#define IAP_BOOT_PIN_FC_REG                      (0x0F3D)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F30)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F09)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F22)
#define IAP_BOOT_PIN_PRD_REG                     (0x0016)
#define IAP_BOOT_PIN_BIT                         (0x01)
#endif

#ifdef IAP_BOOT_PIN_P91
#define IAP_BOOT_PIN_FC_REG                      (0x0F3D)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F30)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F09)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F22)
#define IAP_BOOT_PIN_PRD_REG                     (0x0016)
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

#ifdef IAP_BOOT_PIN_P92
#define IAP_BOOT_PIN_FC_REG                      (0x0F3D)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F30)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F09)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F22)
#define IAP_BOOT_PIN_PRD_REG                     (0x0016)
#define IAP_BOOT_PIN_BIT                         (0x04)
#endif

#ifdef IAP_BOOT_PIN_P93
#define IAP_BOOT_PIN_FC_REG                      (0x0F3D)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F30)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F09)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F22)
#define IAP_BOOT_PIN_PRD_REG                     (0x0016)
#define IAP_BOOT_PIN_BIT                         (0x08)
#endif
#endif
/* -------------------------------------------------------------*/
/* -------------------------------------------------------------*/

// ============================================================ //
#endif
// ============================================================ //
// 
// 

